/// \file DialogBoxesGTK.hpp Header file for the DialogBoxesGTK class

/// Include guard for DialogBoxesGTK.hpp
#ifndef INCLUDED_DIALOGBOXESGTK_H
#define INCLUDED_DIALOGBOXESGTK_H 1

#include "DialogBoxes.hpp"

/**
 * \brief Class for interacting with the user through window-system dialog boxes
 */
class DialogBoxesGTK : public DialogBoxes
{
public:
	DialogBoxesGTK(int *argc, char ***argv);

	void WarningMessage(const char *format, ...);

	void ErrorMessage(const char *format, ...);

	bool PromptSaveLevel(std::string& filename, const char *dirname = 0);

	bool PromptOpenLevel(std::string& filename, const char *dirname = 0);

private:
	void HandlePendingEvents(void);
};

#endif /* INCLUDED_DIALOGBOXESGTK_H */
// vim: set ts=4 sts=4 sw=4 noet:
