/// \file DialogBoxesWindows.hpp Header file for the DialogBoxesWindows class

/// Include guard for DialogBoxesWindows.hpp
#ifndef INCLUDED_DIALOGBOXESWINDOWS_H
#define INCLUDED_DIALOGBOXESWINDOWS_H 1

#define WIN32_LEAN_AND_MEAN 1
#include <windows.h>

#include "DialogBoxes.hpp"

/**
 * \brief Class for interacting with the user through window-system dialog boxes
 */
class DialogBoxesWindows : public DialogBoxes
{
public:
	DialogBoxesWindows::DialogBoxesWindows();

	void WarningMessage(const char *format, ...);

	void ErrorMessage(const char *format, ...);

	bool PromptSaveLevel(std::string& filename, const char *dirname = 0);

	bool PromptOpenLevel(std::string& filename, const char *dirname = 0);

private:
	void GetWinHandle();
	friend BOOL CALLBACK TestWindow(HWND hwnd, LPARAM lparam);

	HWND windowhandle;
};

#endif /* INCLUDED_DIALOGBOXESWINDOWS_H */
// vim: set ts=4 sts=4 sw=4 noet:
