/// \file MainMenu.cpp Source file for the MainMenu class

#include <vector>
#include <iostream>
#include <stdexcept>
#include <string>

#include "Utility.hpp"
#include "MainMenu.hpp"

MainMenu::MainMenu(int width, int height) :
	state(MENU_STATE_INTRO),
	needrestart(false),
	Story (width*1/3,height*3/9,width*1/12,width*1/3,"",PKGDATADIR"Artwork/ui/mainmenu/story_mode.png"),
	Load (width*1/3,height*4/9,width*1/12,width*1/3,"",PKGDATADIR"Artwork/ui/mainmenu/load_level.png"),
	Editor (width*1/3,height*5/9,width*1/12,width*1/3,"",PKGDATADIR"Artwork/ui/mainmenu/level_editor.png"),
	Options (width*1/3,height*6/9,width*1/12,width*1/3,"",PKGDATADIR"Artwork/ui/mainmenu/options.png"),
	Exit (width*1/3,height*7/9,width*1/12,width*1/3,"",PKGDATADIR"Artwork/ui/mainmenu/exit.png"),
	StartStory (width*1/3,height/3,width*1/12,width*1/3,"",PKGDATADIR"Artwork/ui/mainmenu/start_story.png"),
	ContinueStory (width*1/3,height*4/9,width*1/12,width*1/3,"",PKGDATADIR"Artwork/ui/mainmenu/continue_story.png"),
	BackToMain (width*1/3,height*7/9,width*1/12,width*1/3,"",PKGDATADIR"Artwork/ui/mainmenu/backtomain.png"),
	CreateLevel (width*1/3,height/3,width*1/12,width*1/3,"",PKGDATADIR"Artwork/ui/mainmenu/create_level.png"),
	Fullscreen (width*1/3,height/3,width*1/12,width*1/3,"NOSFX",PKGDATADIR"Artwork/ui/mainmenu/fullscreen.png"),
	Music (width*1/3,height*4/9,width*1/12,width*1/3,"NOSFX",PKGDATADIR"Artwork/ui/mainmenu/sounds.png"),
	LoadLevel1 (width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/intro-tiger.png"),
	LoadLevel2 (width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/intro-flower.png"),
	LoadLevel3 (2*width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/intro-snake.png"),
	LoadLevel4 (3*width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/intro-bee.png"),
	LoadLevel5 (4*width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/intro-switches.png"),
	LoadLevel6 (width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/intro-powerbfly.png"),
	LoadLevel7 (width/6+width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-simple.png"),
	LoadLevel8 (2*width/6+width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-snakepit.png"),
	LoadLevel9 (3*width/6+width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-snake.png"),
	LoadLevel10 (4*width/6+width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-bluered.png"),
	LoadLevel11 (width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-dejavu.png"),
	LoadLevel12 (width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/intro-bat.png"),
	LoadLevel13 (2*width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-2roads.png"),
	LoadLevel14 (3*width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/intro-scorpion.png"),
	LoadLevel15 (4*width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-aroundlake.png"),
	LoadLevel16 (width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-yingyang.png"),
	LoadLevel17 (width/6+width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-hide.png"),
	LoadLevel18 (2*width/6+width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-lake.png"),
	LoadLevel19 (3*width/6+width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-around.png"),
	LoadLevel20 (4*width/6+width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-centilead.png"),
	LoadLevel21 (width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-switches.png"),
	LoadLevel22 (width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-batcave.png"),
	LoadLevel23 (2*width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-sym.png"),
	LoadLevel24 (3*width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-longdark.png"),
	LoadLevel25 (4*width/6+width/15,height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-race.png"),
	LoadLevel26 (width/15,2*height/9+height*7/20,height/5,height/5,"",PKGDATADIR"Artwork/ui/mainmenu/level_previews/level-argh.png"),
	Page1 (width*8/9,height*13/32,height/18,height/18,"NOSFX",PKGDATADIR"Artwork/ui/mainmenu/level_previews/pages/p1.png"),
	Page2 (width*8/9,height*15/32,height/18,height/18,"NOSFX",PKGDATADIR"Artwork/ui/mainmenu/level_previews/pages/p2.png"),
	Page3 (width*8/9,height*17/32,height/18,height/18,"NOSFX",PKGDATADIR"Artwork/ui/mainmenu/level_previews/pages/p3.png"),
	Page4 (width*8/9,height*19/32,height/18,height/18,"NOSFX",PKGDATADIR"Artwork/ui/mainmenu/level_previews/pages/p4.png"),
	LoadFile (width*4/6,height*7/9,width*1/12,width*1/3,"",PKGDATADIR"Artwork/ui/mainmenu/load_file.png")
{
	// Introductory level sequence
	storyLevels.push_back(PKGDATADIR"Levels/intro_tiger.xml");
	storyLevels.push_back(PKGDATADIR"Levels/intro_flower.xml");
	storyLevels.push_back(PKGDATADIR"Levels/intro_snake.xml");
	storyLevels.push_back(PKGDATADIR"Levels/intro_bee.xml");
	storyLevels.push_back(PKGDATADIR"Levels/intro_switches.xml");
	storyLevels.push_back(PKGDATADIR"Levels/intro_powerbfly.xml");
	
	// Medium-difficulty levels
	storyLevels.push_back(PKGDATADIR"Levels/level-simple.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level-snakepit.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level_snake.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level-bluered.xml");
	storyLevels.push_back(PKGDATADIR"Levels/intermediate-collect-dejavu.xml");
	storyLevels.push_back(PKGDATADIR"Levels/intro_bat.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level-2roads.xml");
	storyLevels.push_back(PKGDATADIR"Levels/intro_scorpion.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level-roundthelake.xml");
	storyLevels.push_back(PKGDATADIR"Levels/intermediate-collect-yingyang.xml");
	storyLevels.push_back(PKGDATADIR"Levels/intermediate-goal-hide.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level_lake.xml");
	
	// Difficult levels
	storyLevels.push_back(PKGDATADIR"Levels/hard-survive-around.xml");	
	storyLevels.push_back(PKGDATADIR"Levels/level-centilead.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level-switches.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level-batcave.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level-sym.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level_thelongdark.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level-race.xml");
	storyLevels.push_back(PKGDATADIR"Levels/level-argh.xml");

	intro_pic = LoadImageSDL(PKGDATADIR"Artwork/ui/mainmenu/intro.png", width, height);
	victory_pic = LoadImageSDL(PKGDATADIR"Artwork/ui/mainmenu/victory_screen.png", width, height);
	mainmenubg_pic = LoadImageSDL(PKGDATADIR"Artwork/ui/mainmenu/main_menu_bg.png", width, height);
	mainmenu_border1 = LoadImageSDL(PKGDATADIR"Artwork/ui/mainmenu/main_menu_fade1.png", width*2/5, 5*height/9);
	mainmenu_border2 = LoadImageSDL(PKGDATADIR"Artwork/ui/mainmenu/main_menu_fade2.png", 9*width/10, 5*height/9);
	needrestart_pic = LoadImageSDL(PKGDATADIR"Artwork/ui/mainmenu/needrestart.png", width*4/15, height*2/25);
	level_editor_pic = LoadImageSDL(PKGDATADIR"Artwork/ui/level_editor/level_editor_bg.png");

	MainMenus.push_back(&Story);
	MainMenus.push_back(&Load);
	// Currently disabled, not yet fixed for SDL Transition
	//MainMenus.push_back(&Editor);
	MainMenus.push_back(&Options);
	MainMenus.push_back(&Exit);

	StoryMenus.push_back(&StartStory);
	StoryMenus.push_back(&ContinueStory);
	StoryMenus.push_back(&BackToMain);

//	LoadMenus.push_back(&LoadFile);
//	LoadMenus.push_back(&BackToMain);
	LoadMenus.push_back(&LoadLevel1);
	LoadMenus.push_back(&LoadLevel2);
	LoadMenus.push_back(&LoadLevel3);
	LoadMenus.push_back(&LoadLevel4);
	LoadMenus.push_back(&LoadLevel5);
	LoadMenus.push_back(&LoadLevel6);
	LoadMenus.push_back(&LoadLevel7);
	LoadMenus.push_back(&LoadLevel8);
	LoadMenus.push_back(&LoadLevel9);
	LoadMenus.push_back(&LoadLevel10);
	LoadMenus.push_back(&LoadLevel11);
	LoadMenus.push_back(&LoadLevel12);
	LoadMenus.push_back(&LoadLevel13);
	LoadMenus.push_back(&LoadLevel14);
	LoadMenus.push_back(&LoadLevel15);
	LoadMenus.push_back(&LoadLevel16);
	LoadMenus.push_back(&LoadLevel17);
	LoadMenus.push_back(&LoadLevel18);
	LoadMenus.push_back(&LoadLevel19);
	LoadMenus.push_back(&LoadLevel20);
	LoadMenus.push_back(&LoadLevel21);
	LoadMenus.push_back(&LoadLevel22);
	LoadMenus.push_back(&LoadLevel23);
	LoadMenus.push_back(&LoadLevel24);
	LoadMenus.push_back(&LoadLevel25);
	LoadMenus.push_back(&LoadLevel26);

	PageMenus.push_back(&Page1);
	PageMenus.push_back(&Page2);
	PageMenus.push_back(&Page3);
	PageMenus.push_back(&Page4);

	EditorMenus.push_back(&CreateLevel);
	EditorMenus.push_back(&Load);
	EditorMenus.push_back(&BackToMain);

	Fullscreen.SetToggled(config->GetFullscreen());
	Music.SetToggled(config->GetSoundEnabled());
	OptionsMenus.push_back(&Fullscreen);
	OptionsMenus.push_back(&Music);
	OptionsMenus.push_back(&BackToMain);

	if (FileExists(PKGDATADIR"Sounds/Geuka-MainMenu.wav"))
		menumusic = LoadSound(PKGDATADIR"Sounds/Geuka-MainMenu.wav");
	else
		menumusic = LoadSound(PKGDATADIR"Sounds/Geuka-MainMenu.ogg");
	SoundManager::PlayMusic(menumusic);

	pageSelected = 0;
	PageMenus[pageSelected]->SetToggled(true);
}

MainMenu::~MainMenu()
{
	if (state == MENU_STATE_GAME)
		delete runningLevel;
	else if (state == MENU_STATE_EDITOR_RUN)
		delete runningEditor;

	SoundManager::StopMusic(menumusic);
	Mix_FreeChunk(menumusic);
}

void MainMenu::Reset()
{
	SwitchState(MENU_STATE_MAIN);
}

void MainMenu::Update()
{
	switch (state) {
		case MENU_STATE_GAME:
			if (!runningLevel->IsFinished() && !runningLevel->IsQuit()) {
				runningLevel->Update();
				return;
			} else if (runningLevel->IsQuit()) {
				delete runningLevel;
				SwitchState(MENU_STATE_MAIN);
			} else {
				delete runningLevel;
				if (mode == GAME_MODE_STORY) {
					config->SetLevelsCompleted(levelNumber+1);
					for (levelNumber++, runningLevel=0;
						 levelNumber<storyLevels.size() && !runningLevel;
						 levelNumber++) {
						try {
							runningLevel = new LevelUI(storyLevels[levelNumber].c_str());
							return;
						} catch (std::runtime_error& error) {
							dialogs->ErrorMessage("Error loading %s:\n%s",
												  storyLevels[levelNumber].c_str(),
												  error.what());
						}
					}
					SwitchState(MENU_STATE_VICTORY); // Victory!
				} else {
					SwitchState(MENU_STATE_LOAD);
				}
			}
			break;

		case MENU_STATE_EDITOR_RUN:
			if (!runningEditor->New() && !runningEditor->Exit()) {
				runningEditor->Run();
				return;
			}
			if (runningEditor->New()) {
				delete runningEditor;
				StartLevelEditor();
			} else if (runningEditor->Exit()) {
				delete runningEditor;
				SwitchState(MENU_STATE_MAIN);
			}
			break;
	}
}

void MainMenu::KeyboardEvent(SDL_KeyboardEvent *event)
{
	if (state == MENU_STATE_GAME)
		runningLevel->KeyboardEvent(event);
	else if (state == MENU_STATE_EDITOR_RUN)
		runningEditor->KeyboardEvent(event);

	if (event->type != SDL_KEYDOWN)
		return;

	switch (state) {
		case MENU_STATE_INTRO:
		case MENU_STATE_VICTORY:
			SwitchState(MENU_STATE_MAIN);
			break;
		case MENU_STATE_MAIN:
			switch (event->keysym.sym) {
				case SDLK_s:
					SwitchState(MENU_STATE_STORY);
					break;
				case SDLK_l:
					SwitchState(MENU_STATE_LOAD);
					break;
				case SDLK_e:
					SwitchState(MENU_STATE_EDITOR);
					break;
				case SDLK_o:
					SwitchState(MENU_STATE_OPTIONS);
					break;
				case SDLK_x:
					SwitchState(MENU_STATE_EXIT);
					break;
				default:
					// Not a hotkey
					break;
			}
			break;
		case MENU_STATE_STORY:
			switch (event->keysym.sym) {
				case SDLK_s:
					LoadLevel(0);
					break;
				case SDLK_c:
					LoadLevel(config->GetLevelsCompleted());
					break;
				case SDLK_m:
					SwitchState(MENU_STATE_MAIN);
					break;
				default:
					// Not a hotkey
					break;
			}
			break;
		case MENU_STATE_LOAD:
			switch (event->keysym.sym) {
				case SDLK_l:
					{
						std::string filename;
						if (dialogs->PromptOpenLevel(filename, GetWorkingDirectory()))
							LoadLevel(filename);
					}
					break;
				case SDLK_m:
					SwitchState(MENU_STATE_MAIN);
					break;
				case SDLK_1:
					PageMenus[pageSelected]->SetToggled(false);
					pageSelected = 0;
					PageMenus[pageSelected]->SetToggled(true);
					break;
				case SDLK_2:
					PageMenus[pageSelected]->SetToggled(false);
					pageSelected = 1;
					PageMenus[pageSelected]->SetToggled(true);
					break;
				case SDLK_3:
					PageMenus[pageSelected]->SetToggled(false);
					pageSelected = 2;
					PageMenus[pageSelected]->SetToggled(true);
					break;
				case SDLK_4:
					PageMenus[pageSelected]->SetToggled(false);
					pageSelected = 3;
					PageMenus[pageSelected]->SetToggled(true);
					break;
				default:
					// Not a hotkey
					break;
			}
			break;
		case MENU_STATE_EDITOR:
			switch (event->keysym.sym) {
				case SDLK_c:
					StartLevelEditor();
					break;
				case SDLK_o:
					{
						std::string filename;
						if (dialogs->PromptOpenLevel(filename, GetWorkingDirectory()))
							StartLevelEditor(filename);
					}
					break;
				case SDLK_m:
					SwitchState(MENU_STATE_MAIN);
					break;
				default:
					// Not a hotkey
					break;
			}
			break;
		case MENU_STATE_OPTIONS:
			switch (event->keysym.sym) {
				case SDLK_f:
					if (!SDL_WM_ToggleFullScreen(SDL_GetVideoSurface()))
						needrestart = true;

					Fullscreen.SetToggled(config->GetFullscreen());
					config->SetFullscreen(!config->GetFullscreen());
					break;
				case SDLK_s:
					config->SetSoundEnabled(!config->GetSoundEnabled());
					Music.SetToggled(config->GetSoundEnabled());

					if (!config->GetSoundEnabled())
						SoundManager::StopMusic(menumusic);
					else
						SoundManager::PlayMusic(menumusic);
					break;
				case SDLK_m:
					try {
						config->Save();
					} catch (...) {
						std::cerr << "Error saving configuration\n";
					}
					SwitchState(MENU_STATE_MAIN);
					break;
				default:
					// Not a hotkey
					break;
			}
			break;

	}
}

void MainMenu::MouseMotionEvent(SDL_MouseMotionEvent *event)
{
	// Propagate the event if we need to
	if (state == MENU_STATE_GAME)
		runningLevel->MouseMotionEvent(event);
	else if (state == MENU_STATE_EDITOR_RUN)
		runningEditor->MouseMotionEvent(event);

	switch (state) {
		case MENU_STATE_MAIN:
			for (unsigned int i=0; i<MainMenus.size(); i++) {
				if (MainMenus[i]->OnButton(event->x, event->y))
					MainMenus[i]->SetState(Button::BUTTON_STATE_HOVER);
				else
					MainMenus[i]->SetState(Button::BUTTON_STATE_DEFAULT);
			}
			break;
		case MENU_STATE_STORY:
			for (unsigned int i=0; i<StoryMenus.size(); i++) {
				if (StoryMenus[i]->OnButton(event->x, event->y))
					StoryMenus[i]->SetState(Button::BUTTON_STATE_HOVER);
				else
					StoryMenus[i]->SetState(Button::BUTTON_STATE_DEFAULT);
			}
			break;
		case MENU_STATE_LOAD:
			if (LoadFile.OnButton(event->x, event->y))
				LoadFile.SetState(Button::BUTTON_STATE_HOVER);
			else
				LoadFile.SetState(Button::BUTTON_STATE_DEFAULT);

			if (BackToMain.OnButton(event->x, event->y))
				BackToMain.SetState(Button::BUTTON_STATE_HOVER);
			else
				BackToMain.SetState(Button::BUTTON_STATE_DEFAULT);

			for (unsigned int i=pageSelected*10;
				 i<pageSelected*10+10 && i<LoadMenus.size(); i++) {
				if (LoadMenus[i]->OnButton(event->x, event->y)) {
					LoadMenus[i]->SetState(Button::BUTTON_STATE_HOVER);
				} else {
					LoadMenus[i]->SetState(Button::BUTTON_STATE_DEFAULT);
				}
			}

			for (unsigned int i=0; i<PageMenus.size(); i++) {
				if (PageMenus[i]->OnButton(event->x, event->y))
					PageMenus[i]->SetState(Button::BUTTON_STATE_HOVER);
				else
					PageMenus[i]->SetState(Button::BUTTON_STATE_DEFAULT);
			}
			break;
		case MENU_STATE_EDITOR:
			for (unsigned int i=0; i<EditorMenus.size(); i++) {
				if (EditorMenus[i]->OnButton(event->x, event->y))
					EditorMenus[i]->SetState(Button::BUTTON_STATE_HOVER);
				else
					EditorMenus[i]->SetState(Button::BUTTON_STATE_DEFAULT);
			}
			break;
		case MENU_STATE_OPTIONS:
			for (unsigned int i=0; i<OptionsMenus.size(); i++) {
				if (OptionsMenus[i]->OnButton(event->x, event->y))
					OptionsMenus[i]->SetState(Button::BUTTON_STATE_HOVER);
				else
					OptionsMenus[i]->SetState(Button::BUTTON_STATE_DEFAULT);
			}
			break;
	}
}

void MainMenu::MouseButtonEvent(SDL_MouseButtonEvent *event)
{
	// Propagate the event if we need to
	if (state == MENU_STATE_GAME)
		runningLevel->MouseButtonEvent(event);
	else if (state == MENU_STATE_EDITOR_RUN)
		runningEditor->MouseButtonEvent(event);

	if (event->type != SDL_MOUSEBUTTONDOWN)
		return;

	switch (state) {
		case MENU_STATE_INTRO:
		case MENU_STATE_VICTORY:
			SwitchState(MENU_STATE_MAIN);
			break;
		case MENU_STATE_MAIN:
			for (unsigned int i=0; i<MainMenus.size(); i++) {
				if (MainMenus[i]->OnButton(event->x, event->y)) {
					MainMenus[i]->SetState(Button::BUTTON_STATE_SELECTED);

					if (MainMenus[i] == &Story)
						SwitchState(MENU_STATE_STORY);
					else if (MainMenus[i] == &Load)
						SwitchState(MENU_STATE_LOAD);
					else if (MainMenus[i] == &Editor)
						SwitchState(MENU_STATE_EDITOR);
					else if (MainMenus[i] == &Options)
						SwitchState(MENU_STATE_OPTIONS);
					else if (MainMenus[i] == &Exit)
						SwitchState(MENU_STATE_EXIT);
#ifdef DEBUG
					else
						fprintf(stderr, "Unrecognized menu button pressed\n");
#endif
				}
			}
			break;
		case MENU_STATE_STORY:
			for (unsigned int i=0; i<StoryMenus.size(); i++) {
				if (StoryMenus[i]->OnButton(event->x, event->y)) {
					StoryMenus[i]->SetState(Button::BUTTON_STATE_SELECTED);

					if (StoryMenus[i] == &StartStory)
						LoadLevel(0);
					else if (StoryMenus[i] == &ContinueStory)
						LoadLevel(config->GetLevelsCompleted());
					else if (StoryMenus[i] == &BackToMain)
						SwitchState(MENU_STATE_MAIN);
#ifdef DEBUG
					else
						fprintf(stderr, "Unrecognized menu button pressed\n");
#endif
				}
			}
			break;
		case MENU_STATE_LOAD:
			if (LoadFile.OnButton(event->x, event->y)) {
				LoadFile.SetState(Button::BUTTON_STATE_SELECTED);
				std::string filename;
				if (dialogs->PromptOpenLevel(filename, GetWorkingDirectory()))
					LoadLevel(filename);
				return;
			}

			if (BackToMain.OnButton(event->x, event->y)) {
				BackToMain.SetState(Button::BUTTON_STATE_SELECTED);
				SwitchState(MENU_STATE_MAIN);
				return;
			}

			for (unsigned int i=pageSelected*10;
				 i<pageSelected*10+10 && i<LoadMenus.size(); i++) {
				if (LoadMenus[i]->OnButton(event->x, event->y)) {
					ToggleButton *levelbtn = dynamic_cast<ToggleButton *>(LoadMenus[i]);
					if (levelbtn != NULL) {
						// Draw the Loading state of the button while loading
						levelbtn->SetState(Button::BUTTON_STATE_DEFAULT);
						levelbtn->SetToggled(true);

						SDL_Surface *screen = SDL_GetVideoSurface();
						levelbtn->Draw(screen);
						SDL_UpdateRect(screen,
							levelbtn->GetX(), levelbtn->GetY(),
							levelbtn->GetWidth(), levelbtn->GetHeight());

						LoadLevel(storyLevels[i]);
						levelbtn->SetToggled(false);
					}
#ifdef DEBUG
					else
						std::cerr << "Level button not a toggle!?\n";
#endif
				}
			}

			for (unsigned int i=0; i<PageMenus.size(); i++) {
				if (PageMenus[i]->OnButton(event->x, event->y)) {
					PageMenus[i]->SetState(Button::BUTTON_STATE_SELECTED);
					PageMenus[pageSelected]->SetToggled(false);
					pageSelected = i;
					PageMenus[pageSelected]->SetToggled(true);
				}
			}
			break;
		case MENU_STATE_EDITOR:
			{
			for (unsigned int i=0; i<EditorMenus.size(); i++) {
				if (EditorMenus[i]->OnButton(event->x, event->y)) {
					EditorMenus[i]->SetState(Button::BUTTON_STATE_SELECTED);
					std::string filename;

					if (EditorMenus[i] == &CreateLevel)
						StartLevelEditor();
					else if (EditorMenus[i] == &Load)
					{
						if (dialogs->PromptOpenLevel(filename, GetWorkingDirectory()))
							StartLevelEditor(filename);
					}
					else if (EditorMenus[i] == &BackToMain)
						SwitchState(MENU_STATE_MAIN);
#ifdef DEBUG
					else
						fprintf(stderr, "Unrecognized menu button pressed\n");
#endif
				}
			}
			}
			break;
		case MENU_STATE_OPTIONS:
			{
			for (unsigned int i=0; i<OptionsMenus.size(); i++) {
				if (OptionsMenus[i]->OnButton(event->x, event->y)) {
					OptionsMenus[i]->SetState(Button::BUTTON_STATE_SELECTED);

					if (OptionsMenus[i] == &Fullscreen)
					{
						if (!SDL_WM_ToggleFullScreen(SDL_GetVideoSurface()))
							needrestart = true;

						config->SetFullscreen(!config->GetFullscreen());
						Fullscreen.SetToggled(config->GetFullscreen());
					}
					else if (OptionsMenus[i] == &Music)
					{
						config->SetSoundEnabled(!config->GetSoundEnabled());
						Music.SetToggled(config->GetSoundEnabled());

						if (!config->GetSoundEnabled())
							SoundManager::StopMusic(menumusic);
						else
							SoundManager::PlayMusic(menumusic);
					}
					else if (OptionsMenus[i] == &BackToMain)
					{
						config->Save();
						SwitchState(MENU_STATE_MAIN);
					}
#ifdef DEBUG
					else
						fprintf(stderr, "Unrecognized menu button pressed\n");
#endif
				}
			}
			}
			break;
	}
}

void MainMenu::Draw(SDL_Surface *screen) const
{
	SDL_Rect offset;
	switch(state){
		case MENU_STATE_INTRO:
			offset.x = 0;
			offset.y = 0;
			SDL_BlitSurface(intro_pic, NULL, screen, &offset);
			break;
		case MENU_STATE_VICTORY:
			offset.x = 0;
			offset.y = 0;
			SDL_BlitSurface(victory_pic, NULL, screen, &offset);
			break;
		case MENU_STATE_MAIN:
			offset.x = 0;
			offset.y = 0;
			SDL_BlitSurface(mainmenubg_pic, NULL, screen, &offset);
			offset.x = screen->w/2 - mainmenu_border1->w/2;
			offset.y = screen->h/3;
			SDL_BlitSurface(mainmenu_border1, NULL, screen, &offset);
			for (unsigned int i=0; i<MainMenus.size(); i++)
				MainMenus[i]->Draw(screen);
			break;
		case MENU_STATE_STORY:
			offset.x = 0;
			offset.y = 0;
			SDL_BlitSurface(mainmenubg_pic, NULL, screen, &offset);
			offset.x = screen->w/2 - mainmenu_border1->w/2;
			offset.y = screen->h/3;
			SDL_BlitSurface(mainmenu_border1, NULL, screen, &offset);
			for (unsigned int i=0; i<StoryMenus.size(); i++)
				StoryMenus[i]->Draw(screen);
			break;
		case MENU_STATE_LOAD:
			offset.x = 0;
			offset.y = 0;
			SDL_BlitSurface(mainmenubg_pic, NULL, screen, &offset);
			offset.x = screen->w/2-mainmenu_border2->w/2;
			offset.y = screen->h/3;
			SDL_BlitSurface(mainmenu_border2, NULL, screen, &offset);
			LoadFile.Draw(screen);
			BackToMain.Draw(screen);
			for (unsigned int i=pageSelected*10;
				 i<(pageSelected+1)*10 && i<LoadMenus.size(); i++) {
				LoadMenus[i]->Draw(screen);
			}
			for (unsigned int i=0; i<PageMenus.size(); i++) {
				PageMenus[i]->Draw(screen);
			}
			break;
		case MENU_STATE_EDITOR:
			offset.x = 0;
			offset.y = 0;
			SDL_BlitSurface(mainmenubg_pic, NULL, screen, &offset);
			offset.x = screen->w/2 - mainmenu_border1->w/2;
			offset.y = screen->h/3;
			SDL_BlitSurface(mainmenu_border1, NULL, screen, &offset);
			for (unsigned int i=0; i<EditorMenus.size(); i++)
				EditorMenus[i]->Draw(screen);
			break;
		case MENU_STATE_OPTIONS:
			offset.x = 0;
			offset.y = 0;
			SDL_BlitSurface(mainmenubg_pic, NULL, screen, &offset);
			offset.x = screen->w/2 - mainmenu_border1->w/2;
			offset.y = screen->h/3;
			SDL_BlitSurface(mainmenu_border1, NULL, screen, &offset);
			for (unsigned int i=0; i<OptionsMenus.size(); i++)
				OptionsMenus[i]->Draw(screen);

			if (needrestart) {
				offset.x = screen->w*3/4 + mainmenu_border1->w/4
							- needrestart_pic->w/2;
				offset.y /= 2;
				SDL_BlitSurface(needrestart_pic, NULL, screen, &offset);
			}
			break;
		case MENU_STATE_EXIT:
			break;
		case MENU_STATE_GAME:
			runningLevel->Draw(screen);
			break;
		case MENU_STATE_EDITOR_RUN:
			offset.x = 0;
			offset.y = 0;
			SDL_BlitSurface(level_editor_pic, NULL, screen, &offset);
			runningEditor->Draw(screen);
			break;
	}
}

void MainMenu::LoadLevel(unsigned int levelNumber)
{
	try {
		runningLevel = new LevelUI(storyLevels[levelNumber].c_str());
		this->levelNumber = levelNumber;
		SwitchState(MENU_STATE_GAME);
	} catch (std::runtime_error& error) {
		dialogs->ErrorMessage("Error loading %s:\n%s",
							  storyLevels[levelNumber].c_str(),
							  error.what());
	}
}

void MainMenu::LoadLevel(const std::string& levelfile)
{
	try {
		runningLevel = new LevelUI(levelfile.c_str());
		SwitchState(MENU_STATE_GAME);
	} catch (std::runtime_error& error) {
		dialogs->ErrorMessage("Error loading %s:\n%s",
							  levelfile.c_str(),
							  error.what());
	}
}

void MainMenu::StartLevelEditor()
{
	try {
		runningEditor = new LevelEditor(20,20);
		SwitchState(MENU_STATE_EDITOR_RUN);
	} catch (std::runtime_error& error) {
		dialogs->ErrorMessage("Error loading level editor:\n%s",
							  error.what());
	}
}

void MainMenu::StartLevelEditor(const std::string& levelfile)
{
	try {
		runningEditor = new LevelEditor(levelfile.c_str());
		SwitchState(MENU_STATE_EDITOR_RUN);
	} catch (std::runtime_error& error) {
		dialogs->ErrorMessage("Error loading %s:\n%s",
							  levelfile.c_str(),
							  error.what());
	}
}

void MainMenu::SwitchState(MenuState newstate)
{
	if (newstate == MENU_STATE_STORY)
		mode = GAME_MODE_STORY;
	else if (newstate == MENU_STATE_LOAD)
		mode = GAME_MODE_LOADLEVEL;
	else if (newstate == MENU_STATE_EXIT)
		quit = true;

	switch (newstate) {
		case MENU_STATE_STORY:
		case MENU_STATE_MAIN:
		case MENU_STATE_LOAD:
		case MENU_STATE_OPTIONS:
		case MENU_STATE_EXIT:
		case MENU_STATE_EDITOR:
			if (state == MENU_STATE_GAME ||
				state == MENU_STATE_EDITOR_RUN)
				SoundManager::PlayMusic(menumusic);
			break;
		case MENU_STATE_GAME:
		case MENU_STATE_EDITOR_RUN:
			SoundManager::StopMusic(menumusic);
			break;
	}

	state = newstate;
}

// vim: set ts=4 sts=4 sw=4 noet:
