/// \file Saveable.hpp Header file for the Saveable interface

/// Include guard for Saveable.hpp
#ifndef INCLUDED_SAVEABLE_H
#define INCLUDED_SAVEABLE_H 1

/** \brief Class representing an object that can be saved to XML */
class Saveable {
public:
	/** \brief Get the XML representation of this object
	 *
	 * \param indent The indentation that should be applied at the beginning
	 * of each line of the XML
	 * \return String containing the XML representation of this object
	 */
	virtual std::string GetXMLRepresentation(const std::string& indent = "") const =0;
};

#endif /* INCLUDED_SAVEABLE_H */
