#include <iostream>
#include <string>

#include "Utility.hpp"
#include "ToggleButton.hpp"

ToggleButton::ToggleButton(int bx, int by,
			   int bheight, int bwidth,
			   std::string bmessage, std::string bpath) :
	Button(bx, by, bheight, bwidth, bmessage, bpath),
	toggled(false)
{
}

ToggleButton::ToggleButton(int bx, int by,
			   int bheight, int bwidth,
			   std::string bmessage, ButtonType btype) :
	Button(bx, by, bheight, bwidth, bmessage, btype),
	toggled(false)
{
}

void ToggleButton::Draw(SDL_Surface *screen) const
{
	if (message != "LE" && message != "LE-C") {
		int frame;
		if (GetState() == BUTTON_STATE_DEFAULT) {
			if (toggled)
				frame = 2;
			else
				frame = 0;
		} else {
			frame = 1;
		}

		SDL_Rect clip, offset;
		clip.x = 0;
		clip.y = frame*height;
		clip.w = width;
		clip.h = height;
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface(image, &clip, screen, &offset);
	} else {
		Button::Draw(screen);
	}
}
// vim: set ts=4 sts=4 sw=4 noet:
