#ifndef INCLUDED_TOGGLEBUTTON_H
#define INCLUDED_TOGGLEBUTTON_H 1

#ifdef WITH_GLSDL
# include "glSDL.h"
#else
# include "SDL.h"
#endif

#include "Button.hpp"

class ToggleButton : public Button {
public:
	ToggleButton(int x, // (0,0) is top left of button
		   int y,
		   int height,
		   int width,
		   std::string message,
		   std::string path);

	ToggleButton(int x, // (0,0) is top left of button
		   int y,
		   int height,
		   int width,
		   std::string message,
		   ButtonType type);

	void Draw(SDL_Surface *screen) const;
	bool GetToggled() const;
	void SetToggled(bool t) { toggled = t; }
	
private:
	bool toggled;
};

#endif /* INCLUDED_TOGGLEBUTTON_H */
// vim: set ts=4 sts=4 sw=4 noet:
