/// \file Configuration.hpp Header file for the Configuration class

/// Include guard for Charlie.hpp
#ifndef INCLUDED_WINREGCONFIGURATION_H
#define INCLUDED_WINREGCONFIGURATION_H 1

#include "Configuration.hpp"

/**
 * \brief Class representing the configuration information for Geuka to be
 * stored in the Windows registry
 */
class WinRegConfiguration : public Configuration {
public:
	/** \brief Construct Configuration from saved configuration information
	 *
	 * This function initializes the game configuration from the information
	 * saved in the Windows registry.
	 */
	WinRegConfiguration();

	/** \brief Destructs this Configuration instance and saves the current
	 * configuration to disk.
	 */
	~WinRegConfiguration();

	/** \brief Save the configuration information to disk. */
	void Save() const;
};

#endif /* INCLUDED_WINREGCONFIGURATION_H */
// vim: set ts=4 sts=4 sw=4 noet:
